/*
 *  KiteSocket.h
 *  kite
 *
 *  Created by Mooneer Salem on 12/28/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */
 
#ifdef WIN32
#include <winsock2.h>
#else
#include <sys/socket.h>
#endif

class KiteSocket : public KiteObject {
public:
	KiteSocket()
		: KiteObject(false) {
        inherits = KiteObject::getClassinfo();
        this->type = "socket";
		initialize();
		initWinsock();
	}

	KiteSocket(int domain, int type, int protocol) : KiteObject(false),
		instance(true) {
        inherits = KiteSocket::getClassinfo();
        this->type = "socket";
        
		initWinsock();
        thisSocket = socket(domain, type, protocol);
    }

    KiteSocket(int sock) : KiteObject(false), instance(true), thisSocket(sock) {
        inherits = KiteSocket::getClassinfo();
        this->type = "socket";
    }
    
    virtual ~KiteSocket() {
        // Close the connection
#ifdef WIN32
		shutdown(thisSocket, SD_BOTH);
#else
        shutdown(thisSocket, SHUT_RDWR);
#endif
    }
    
    virtual KiteReference<KiteObject> getClassinfo() {
        if (classinfo.getObj() == NULL) {
            classinfo = new KiteSocket();
        }
        return classinfo;
    }
    
    virtual KiteReference<KiteObject>
	create(KiteVM::VM &vm, KiteReference<KiteObject> base, KiteReference<KiteObject> param);
    
    int getSocket() { return thisSocket; }
private:
	bool instance;
	void initialize();
    int thisSocket;
    static KiteReference<KiteObject> classinfo;

#ifdef WIN32
	static bool winsockInit;

	void initWinsock() {
		if (!winsockInit) {
			WSADATA wsaData;
			WSAStartup(MAKEWORD(2, 2), &wsaData);
			winsockInit = true;
		}
	}
#endif
};
